/* FONT.H */
/* REQUIRES: conio.h, stdio.h, stdlib.h, video.h included. */

struct FontStruct{
        unsigned char xsize;
        unsigned char *data;
};

unsigned char FONT_LOADED=0; /* 0=false, 1=true */
unsigned char ysize;
struct FontStruct FONTDATA[256]; /* 256 possible chars */


int loadfont(char *filename);
void deinitfont(void);
unsigned int flputch(unsigned int x, unsigned int y, unsigned char c);
void flputs(unsigned int x, unsigned int y, unsigned char *string);
unsigned int flputchrow(unsigned int x, unsigned int y, unsigned char row, unsigned char c);
void flputsrow(unsigned int x, unsigned int y, unsigned char row, unsigned char *string);

int loadfont(char *filename){
        unsigned int loopvar;
        unsigned int index;
        FILE *fileptr;

        if(FONT_LOADED!=0) deinitfont; /* Make sure any previous font is put away */
        for(loopvar=0;loopvar<256;loopvar++){
                FONTDATA[loopvar].data=NULL; /* Potential memory hole, if font load fails */
                FONTDATA[loopvar].xsize=0;
        }
        fileptr=fopen(filename, "rb");
        if(fileptr==NULL)return 1; /* Error opening file */
        ysize=fgetc(fileptr);
        index=fgetc(fileptr);
        while(!feof(fileptr)){
                FONTDATA[index].xsize=fgetc(fileptr);
                FONTDATA[index].data=malloc(FONTDATA[index].xsize*ysize);
                if(FONTDATA[index].data==NULL) return 2; /* Error: Not enough mem for malloc */
                for(loopvar=0;loopvar<FONTDATA[index].xsize*ysize;loopvar++)
                        FONTDATA[index].data[loopvar]=fgetc(fileptr);
                index=fgetc(fileptr);
        }
        fclose(fileptr); /* Free the file pointer or the president dies! */
        FONT_LOADED=1; /* Font loaded now equal to true */
        return 0; /* font loaded ok, tell caller so. */
}

void deinitfont(void){
        unsigned int loopvar;

        for(loopvar=0;loopvar<256;loopvar++){
                if(FONTDATA[loopvar].data!=NULL)
                        free(FONTDATA[loopvar].data);
                FONTDATA[loopvar].xsize=0;
        }
        FONT_LOADED=0; /* Font is now longer loaded, it's flat broke :) */
}

unsigned int flputch(unsigned int x, unsigned int y, unsigned char c){
        unsigned int loopvar,loopvar2;
        unsigned int index=0;

        for(loopvar=0;loopvar<ysize;loopvar++){
                for(loopvar2=0;loopvar2<FONTDATA[c].xsize;loopvar2++){
                        pset(x+loopvar2, y+loopvar, FONTDATA[c].data[index]);
                        index++;
                }
        }
        return FONTDATA[c].xsize;
}

void flputs(unsigned int x, unsigned int y, unsigned char *string){
        while(*string!='\0'){
                x+=flputch(x,y,*string);
                string++;
        }
        
}

unsigned int flputchrow(unsigned int x, unsigned int y, unsigned char row, unsigned char c){
        unsigned int loopvar;
        unsigned int index=0;

        index=row*FONTDATA[c].xsize;

        for(loopvar=0;loopvar<FONTDATA[c].xsize;loopvar++){
                pset(x+loopvar, y, FONTDATA[c].data[index]);
                index++;
        }
        
        return FONTDATA[c].xsize;
        
}


void flputsrow(unsigned int x, unsigned int y, unsigned char row, unsigned char *string){
        while(*string!='\0'){
                x+=flputchrow(x,y,row,*string);
                string++;
        }
}
